(document:surround "/std/frame")

(define (update-datetime data)
  (date-set value (woo-get-option data 'date))
  (time-set value (woo-get-option data 'time)))

(define (write-datetime)
  (woo-catch/message
   (thunk
    (woo-write "/datetime"
               'date (date-set value)
               'time (time-set value)
               'ntp_status (ntp-status value)
               'ntp_accept (ntp-accept value)
               'ntp_pool (ntp-pool value))
    (update-datetime (woo-read-first "/datetime")))))

(gridbox columns "50;50"
       margin 20
       (gridbox
         columns "50;50"
         colspan 2
         align "left"
         (document:id ntp-status (checkbox text (_ "Get time from NTP server:") name "ntp_status"))
         (hbox (label name "ntp_pool" text (_ "NTP server:") visibility #f)
               (document:id ntp-pool (edit name "ntp_pool"))))

       (document:id ntp-accept (checkbox text (_ "Work as NTP server") widget-name "ntp_accept" name "ntp_accept"))
       (spacer)

       (separator colspan 2)

       (label text (_ "Current date:") align "center" name "date")
       (label text (_ "Current time:") align "center" name "time")

       (document:id date-set (dateedit expanded #t name "date"))
       (document:id time-set (timeedit expanded #t name "time"))

       (label colspan 2)

       (if (global 'frame:next-button)
           (spacer)
           (document:id apply-button
              (button text (_ "Apply") align "left"
                      (when clicked (write-datetime)))))
       (spacer))

(frame:on-next (thunk (or (write-datetime) 'cancel)))
(frame:on-back (thunk (or (write-datetime) 'cancel)))

(effect-disable "ntp_pool" "ntp_status" #f)
(effect-disable "ntp_accept" "ntp_status" #f)
(effect-disable "date" "ntp_status" #t)
(effect-disable "time" "ntp_status" #t)

(document:root 
  (when loaded
   (let ((data (woo-read-first "/datetime")))
     (ntp-status value (woo-get-option data 'ntp_status))
     (ntp-pool value (woo-get-option data 'ntp_pool))
     (ntp-accept value (woo-get-option data 'ntp_accept))
     (update-datetime data)
     (init-effect))))
